#version 300 es

uniform mat4 u_Model;
uniform mat4 u_TransposeInvModel;
uniform mat4 u_Palatte[50];
uniform mat4 u_Projection;
uniform mat4 u_View;
uniform mat4 u_MVP;

layout(location = 6) in vec4 attBoneIds;
layout(location = 7) in vec4 attWeights;
layout(location = 0) in vec3 attPosition;
layout(location = 1) in vec3 attNormal;
out vec3 v_posWS;
out vec3 v_nDirWS;
layout(location = 2) in vec3 attTangent;
out vec3 v_tDirWS;
out vec3 v_bDirWS;
out vec2 v_uv0;
layout(location = 3) in vec2 attTexcoord0;
out vec2 v_uv1;
layout(location = 4) in vec2 attTexcoord1;
out vec4 v_color;
layout(location = 5) in vec4 attColor;

void main()
{
    mat4 _98 = u_Palatte[int(attBoneIds.x)] * attWeights.x;
    mat4 _107 = u_Palatte[int(attBoneIds.y)] * attWeights.y;
    mat4 _129 = u_Palatte[int(attBoneIds.z)] * attWeights.z;
    mat4 _150 = u_Palatte[int(attBoneIds.w)] * attWeights.w;
    mat4 _163 = mat4(((_98[0] + _107[0]) + _129[0]) + _150[0], ((_98[1] + _107[1]) + _129[1]) + _150[1], ((_98[2] + _107[2]) + _129[2]) + _150[2], ((_98[3] + _107[3]) + _129[3]) + _150[3]);
    vec4 _174 = _163 * vec4(attPosition, 1.0);
    vec4 _184 = _163 * vec4(attNormal, 0.0);
    v_posWS = (u_Model * vec4(_174.xyz, 1.0)).xyz;
    v_nDirWS = vec4(normalize((u_TransposeInvModel * vec4(_184.xyz, 0.0)).xyz), 0.0).xyz;
    vec4 _208 = _163 * vec4(attTangent, 0.0);
    v_tDirWS = (u_Model * vec4(_208.xyz, 0.0)).xyz;
    v_bDirWS = cross(v_nDirWS, v_tDirWS);
    v_uv0 = attTexcoord0;
    v_uv1 = attTexcoord1;
    v_color = attColor;
    v_bDirWS = cross(v_nDirWS, v_tDirWS);
    gl_Position = ((u_Projection * u_View) * vec4(v_posWS, 1.0)) + (u_MVP * vec4(0.0));
}

